<template>
    <div>
        <div class="filters-container">

            <el-input placeholder="关键字" size="small" v-model="filter1" clearable class="filter-item"></el-input>

            <el-button @click="searchData" type="primary" size="small" icon="el-icon-search" class="filter-item">搜索
            </el-button>
            <el-button @click="$router.push({path:'/houseImage',query:{houseId:$route.query.houseId}})" type="primary" size="small" icon="el-icon-edit" class="filter-item">添加
            </el-button>
            <el-dropdown trigger="click" size="medium" class="table-column-filter">
                <span>
                    筛选数据
                    <i class="el-icon-arrow-down el-icon--right"></i>
                </span>
                <el-dropdown-menu slot="dropdown" class="table-column-filter-wrapper">
                    <el-checkbox v-for="item in tableColumns" :key="item.value" v-model="item.show">{{item.label}}
                    </el-checkbox>
                </el-dropdown-menu>
            </el-dropdown>
        </div>
        <el-table :data="tableData" :height="tableHeight" row-key="id" ref="table">
            <el-table-column v-if="multipleMode" align="center" type="selection" width="50">
            </el-table-column>
            <el-table-column type="index" min-width="50" align="center">
            </el-table-column>
            <el-table-column v-if="isColumnShow('houseId')" prop="houseId" label="房源id" min-width="100">
            </el-table-column>
            <el-table-column v-if="isColumnShow('imageType')" prop="imageType" :formatter="imageTypeFormatter" label="类型" min-width="100">
            </el-table-column>
            <el-table-column v-if="isColumnShow('imageName')" prop="imageName" label="名称" min-width="100">
            </el-table-column>
            <el-table-column v-if="isColumnShow('imageUrl')" prop="imageUrl" label="地址" min-width="100">
                <template slot-scope="scope">
                    <img :src="scope.row.imageUrl" @click="showImg(scope.row.imageUrl)" style="width: 100px;height: 100px;vertical-align: middle;" />
                </template>
            </el-table-column>
            <!-- <el-table-column v-if="isColumnShow('createTime')" prop="createTime" label="" min-width="100">
            </el-table-column>
            <el-table-column v-if="isColumnShow('updateTime')" prop="updateTime" label="" min-width="100">
            </el-table-column> -->
            <el-table-column label="操作" align="center" fixed="right">
                <template slot-scope="scope">
                    <el-button @click="editRow(scope.row)" type="primary" size="mini" plain>编辑</el-button>
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <el-pagination background @size-change="pageSizeChange" @current-change="currentPageChange" :current-page="currentPage" :page-sizes="[10, 20, 30, 40, 50]" :page-size="pageSize" layout="total, sizes, prev, pager, next, jumper" :total="totalNumber">
            </el-pagination>
        </div>

        <el-dialog title="查看图片" :visible.sync="imageDialogVisible" size="small">
            <img width="100%" :src="imgSrc" alt="">
        </el-dialog>

    </div>
</template>
<script>
import { mapState } from 'vuex'

export default {
    created() {

        this.getData();
    },
    data() {
        return {
            totalNumber: 0,
            totalPage: 10,
            currentPage: 1,
            pageSize: 20,
            tableData: [],
            filter1: '',
            filter2: '',
            tableColumns: [
                {
                    label: '房源id',
                    value: 'houseId',
                    show: true
                },
                {
                    label: '类型',
                    value: 'imageType',
                    show: true
                },
                {
                    label: '名称',
                    value: 'imageName',
                    show: true
                },
                {
                    label: '地址',
                    value: 'imageUrl',
                    show: true
                },

            ],
            multipleMode: false,
            imgSrc: '',
            imageDialogVisible: false,

        }
    },
    computed: {
        ...mapState(['tableHeight']),
        selection() {
            return this.$refs.table.selection.map(i => i.id);
        }
    },
    methods: {
        pageSizeChange(size) {
            this.currentPage = 1;
            this.pageSize = size;
            this.getData();
        },
        currentPageChange(page) {
            this.currentPage = page;
            this.getData();
        },
        getData() {
            this.$http.get({
                url: '/houseImage/page',
                data: {
                    currentPage: this.currentPage,
                    pageNumber: this.pageSize,
                    houseId: this.$route.query.houseId,
                    searchKey: this.filter1,
                }
            }).then(res => {
                if (res.success) {
                    this.totalNumber = res.data.page.totalNumber;
                    this.tableData = res.data.pp;
                }
            })
        },
        isColumnShow(column) {
            var row = this.tableColumns.find(i => i.value === column);
            return row ? row.show : false;
        },
        toggleMultipleMode(multipleMode) {
            this.multipleMode = multipleMode;
            if (!multipleMode) {
                this.$refs.table.clearSelection();
            }
        },
        editRow(row) {
            this.$router.push({
                path: '/houseImage',
                query: {
                    id: row.id
                }
            })
        },
        operation1() {
            this.$notify({
                title: '提示',
                message: this.selection
            });
        },
        operation2() {
            this.$message('操作2');
        },
        imageTypeFormatter(row, column, cellValue) {
            var valueStr = '';
            switch (cellValue) {
                case 0:
                    valueStr = '图片';
                    break;
                case 1:
                    valueStr = '封面';
                    break
            }

            return valueStr;

        },
        showImg(img) {
            this.imgSrc = img;
            this.imageDialogVisible = true;
        },
        searchData() {
            this.currentPage = 1;
            this.getData();
        }
    }
}
</script>
<style lang="less" scoped>
</style>
